﻿#if !defined(_ACTOR_PLAYER_H_)
#define _ACTOR_PLAYER_H_

#include "IwGeom.h"

#include "IwGameUtil.h"
#include "IwGameSprite.h"
#include "IwGameAnim.h"
#include "IwGameScene.h"
#include "IwGameActor.h"
#include "IwGameImage.h"


//
//
// ActorPlayer - A player character actor
//
//
class ActorPlayer : public CIwGameActorImage
{
public:

protected:
	// Properties
	CIwGameTimer	FadeTimer;
public:
	// Properties end

	ActorPlayer() : CIwGameActorImage() {}
	virtual			~ActorPlayer();
	
	bool			Init(CIwGameScene* scene, CIwGameImage* image, CIwGameAnimImage* anim, int width, int height);
	void			Reset();
	bool			Update(float dt);
	bool			UpdateVisual();
	void			ResolveCollisions();
	void			NotifyCollision(CIwGameActor* other);
	bool			CheckCollision(CIwGameActor* other);

	static ActorPlayer* Create(int x, int y, CIwGameScene* scene, CIwGameImage* image, CIwGameAnimImageFrame* anim_frames);

};


#endif // _ACTOR_PLAYER_H_
