﻿#if !defined(_IW_GAME_H_)
#define _IW_GAME_H_

// Version 0.200
#define	IW_GAME_VERSION		0x00200

#include "IwGameUtil.h"
#include "IwGameActor.h"
#include "IwGameScene.h"
#include "IwGameCamera.h"
#include "IwGameInput.h"

//
//
// CIwGame is a acts as a controller for the whole game. You should derive your own version of this class
// 
// 
//
class CIwGame
{
public:
	// Public access for scene iteration
	typedef CIwList<CIwGameScene*>::iterator	_Iterator;
	_Iterator				begin() { return Scenes.begin(); }
	_Iterator				end() { return Scenes.end(); }

protected:
	//// Properties
	CIwGameScene*			CurrentScene;		// Scene that has current input focus
	CIwGameScene*			NextScene;			// Scene that we wish to switch focus to
	CIwList<CIwGameScene*>	Scenes;				// A collection of game scenes

public:
	void					addScene(CIwGameScene *scene);
	void					removeScene(CIwGameScene* scene);
	void					removeScene(unsigned int name_hash);
	CIwGameScene*			findScene(unsigned int name_hash);
	CIwGameScene*			findScene(const char* name);
	CIwGameScene*			getScene(int index);
	void					clearScenes();
	void					changeScene(CIwGameScene *new_scene);
	bool					changeScene(unsigned int name_hash);
	//// Properties end

protected:
	uint64					LastFrameTime;		// The time at which the last frame ended

public:
	virtual void			Init();
	virtual void			Release();
	virtual bool			Update();
	virtual void			Draw();
	virtual void			Save() {}
	virtual void			Load() {}

private:
public:
	void					SetBackgroundColour(uint8 r, uint8 g, uint8 b, uint8 a);

};

#endif // _IW_GAME_H_
