#include "IwGameImage.h"

//
//
// CIwGameImage implementation
//
//
bool CIwGameImage::Load()
{
	// If already loaded return true
	if (Image2D != NULL)
		return true;

	// Create image from the resource group
	IwGetResManager()->SetCurrentGroup(ResourceGroup);
	Image2D = Iw2DCreateImageResource(NameHash);
	if (Image2D != NULL)
	{
		State = CIwGameImage_State_Loaded;
		return true;
	}

	return false;
}




//
//
// CIwGameImageManager implementation
//
//

void CIwGameImageManager::addImage(const char* resource_name, CIwResGroup* resource_group, bool preload)
{
	CIwGameImage* image = new CIwGameImage();
	image->Init(resource_name, resource_group);
	addImage(image);
	if (preload)
		image->Load();
}

void CIwGameImageManager::addImage(CIwGameImage *image)
{
	// Add an image to the manager
	Images.push_back(image);
	image->setParent(this);
}

void CIwGameImageManager::removeImage(CIwGameImage* image)
{
	removeImage(image->getNameHash());
}

void CIwGameImageManager::removeImage(unsigned int name_hash)
{
	// Renove named image from the manager
	for (_Iterator it = Images.begin(); it != Images.end(); ++it)
	{
		if (name_hash == (*it)->getNameHash())
		{
			delete *it;
			Images.erase(it);
			break;
		}
	}
}

CIwGameImage* CIwGameImageManager::findImage(unsigned int name_hash)
{
	// Find and eturn named image
	for (_Iterator it = Images.begin(); it != Images.end(); ++it)
	{
		if (name_hash == (*it)->getNameHash())
			return *it;
	}

	return NULL;
}

CIwGameImage* CIwGameImageManager::findImage(const char* name)
{
	return findImage(IwHashString(name));
}

void CIwGameImageManager::clearImages()
{
	// Remove and delete all images from the manager
	for (_Iterator it = Images.begin(); it != Images.end(); ++it)
	{
		delete *it;
	}
	Images.clear();
}
